-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_copylayer"

-- **************************************************
-- General information about this script
-- **************************************************

DS_copylayer = {}


function DS_copylayer:Name()
	return "Copy layer settings"
end

function DS_copylayer:Version()
	return "0.1"
end

function DS_copylayer:Description()
	return "Copy positions and stuff between layers"
end


function DS_copylayer:Creator()
	return "dauid.com"
end

function DS_copylayer:UILabel()
	return "Copy layer settings"
end

-- **************************************************
-- Recurring values
-- **************************************************

DS_copylayer.Translation = LM.Vector3:new_local()
DS_copylayer.Translation.x = 0
DS_copylayer.Translation.y = 0
DS_copylayer.Translation.z = 0
DS_copylayer.Scale = LM.Vector3:new_local()
DS_copylayer.Rotation = 0
DS_copylayer.PanTilt = LM.Vector2:new_local()




-- **************************************************
-- The guts of this script
-- **************************************************

function DS_copylayer:IsEnabled(moho)
		return true
end

function DS_copylayer:CopyIt(moho, mouseEvent)
		mouseEvent.view:DrawMe()
end

	
-- **************************************************
-- Menu
-- **************************************************

DS_copylayer.COPY = MOHO.MSG_BASE
DS_copylayer.PASTE = MOHO.MSG_BASE +1
DS_copylayer.RESET = MOHO.MSG_BASE +2

function DS_copylayer:DoLayout(moho, layout)

	self.copyBut= LM.GUI.Button("Copy", self.COPY)
	layout:AddChild(self.copyBut)
	
	self.pasteBut= LM.GUI.Button("Paste", self.PASTE)
	layout:AddChild(self.pasteBut)
	
	self.resetBut= LM.GUI.Button("Reset all", self.RESET)
	layout:AddChild(self.resetBut)
	
	layout:AddChild(LM.GUI.Divider(true))
	
	self.dx=LM.GUI.DynamicText("X: -0.000 ", 4)
	self.dx:SetValue("X: " .. self.Translation.x)
	layout:AddChild(self.dx)
	
	self.dy=LM.GUI.DynamicText("Y: -0.000 ", 4)
	self.dy:SetValue("Y: " .. self.Translation.y)
	layout:AddChild(self.dy)
	
	self.dz=LM.GUI.DynamicText("Z: -0.000 ", 4)
	self.dz:SetValue("Z: " .. self.Translation.z)
	layout:AddChild(self.dz)
	
	self.dsx=LM.GUI.DynamicText("Scale X: -0.000 ", 4)
	self.dsx:SetValue("Scale X: " .. self.Scale.x)
	layout:AddChild(self.dsx)
	
	self.dsy=LM.GUI.DynamicText("Scale Y: -0.000 ", 4)
	self.dsy:SetValue("Scale Y: " .. self.Scale.y)
	layout:AddChild(self.dsy)
	
	self.dsz=LM.GUI.DynamicText("Scale Z: -0.000 ", 4)
	self.dsz:SetValue("Scale Z: " .. self.Scale.z)
	layout:AddChild(self.dsz)
	
	self.drot=LM.GUI.DynamicText("Rotation: -0.000 ", 4)
	self.drot:SetValue("Rotation: " .. self.Rotation)
	layout:AddChild(self.drot)
	
	self.dpan=LM.GUI.DynamicText("Pan: -0.000 ", 4)
	self.dpan:SetValue("Pan: " .. self.PanTilt.x)
	layout:AddChild(self.dpan)
	
	self.dtilt=LM.GUI.DynamicText("Tilt: -0.000 ", 4)
	self.dtilt:SetValue("Tilt: " .. self.PanTilt.y)
	layout:AddChild(self.dtilt)

end


function DS_copylayer:HandleMessage(moho, view, msg)

	if (msg == self.X) then
		self.Translation.x = self.x:FloatValue()
	end
	if (msg == self.COPY) then
		self.Translation = moho.layer.fTranslation:GetValue(moho.frame)
		self.Scale = moho.layer.fScale:GetValue(moho.frame)
		self.Rotation = moho.layer.fRotationZ:GetValue(moho.frame)
		self.PanTilt.x = moho.layer.fRotationX:GetValue(moho.frame)
		self.PanTilt.y = moho.layer.fRotationY:GetValue(moho.frame)
		
		self.dx:SetValue("X: " .. self.Translation.x)
		self.dy:SetValue("Y: " .. self.Translation.y)
		self.dz:SetValue("Z: " .. self.Translation.z)
		self.dsz:SetValue("Scale Z: " .. self.Scale.z)
		self.dsx:SetValue("Scale X: " .. self.Scale.x)
		self.dsy:SetValue("Scale Y: " .. self.Scale.y)
		self.drot:SetValue("Rotation: " .. self.Rotation)
		self.dpan:SetValue("Pan: " .. self.PanTilt.x)
		self.dtilt:SetValue("Tilt: " .. self.PanTilt.y)
		
		
	end
	if (msg == self.PASTE) then
		moho.document:PrepMultiUndo()
		moho.document:SetDirty()
		moho.layer.fTranslation:SetValue(moho.frame, self.Translation)
		moho.layer.fScale:SetValue(moho.frame, self.Scale)
		moho.layer.fRotationZ:SetValue(moho.frame, self.Rotation)
		moho.layer.fRotationX:SetValue(moho.frame, self.PanTilt.x)
		moho.layer.fRotationY:SetValue(moho.frame, self.PanTilt.y)
		
		
	end
	if (msg == self.RESET) then
		moho.document:PrepMultiUndo()
		moho.document:SetDirty()
		
		self.Translation.x = 0
		self.Translation.y = 0
		self.Translation.z = 0
		self.Scale.x = 1
		self.Scale.y = 1
		self.Scale.z = 1
		self.Rotation = 0
		self.PanTilt.x = 0
		self.PanTilt.y = 0
		
		self.dx:SetValue("X: " .. self.Translation.x)
		self.dy:SetValue("Y: " .. self.Translation.y)
		self.dz:SetValue("Z: " .. self.Translation.z)
		self.dsz:SetValue("Scale Z: " .. self.Scale.z)
		self.dsx:SetValue("Scale X: " .. self.Scale.x)
		self.dsy:SetValue("Scale Y: " .. self.Scale.y)
		self.drot:SetValue("Rotation: " .. self.Rotation)
		self.dpan:SetValue("Pan: " .. self.PanTilt.x)
		self.dtilt:SetValue("Tilt: " .. self.PanTilt.y)
		
		moho.layer.fTranslation:SetValue(moho.frame, self.Translation)
		moho.layer.fScale:SetValue(moho.frame, self.Scale)
		moho.layer.fRotationZ:SetValue(moho.frame, self.Rotation)
		moho.layer.fRotationX:SetValue(moho.frame, self.PanTilt.x)
		moho.layer.fRotationY:SetValue(moho.frame, self.PanTilt.y)
		
		
	end
	moho:UpdateUI()
end
