-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_initialize"

-- **************************************************
-- General information about this script
-- **************************************************

DS_initialize = {}

function DS_initialize:Name()
	return "Initialize"
end

function DS_initialize:Version()
	return "0.1"
end

function DS_initialize:Description()
	return "Initialize"
end

function DS_initialize:Creator()
	return "dauid.com"
end

function DS_initialize:UILabel()
	return"Initialize"
end

-- **************************************************
-- The guts of this script
-- **************************************************

function DS_initialize:clearKeys(moho, ch)
local lastFrame = ch:Duration()

for i = 2, lastFrame do
	if ch:HasKey(i) then
		ch:DeleteKey(i)
		--print("Deleted")
	end
end

--ch:CountKeys()
end

function DS_initialize:getChannel(moho, layer)
	local numCh = layer:CountChannels()
	for i = 0, numCh - 2 do
		local chInfo = MOHO.MohoLayerChannel:new_local()
		moho.layer:GetChannelInfo(i, chInfo)
		if (chInfo.subChannelCount == 1) then
			local ch = moho.layer:Channel(i, 0, moho.document)
			self:clearKeys(moho, ch)
		else
			for subID = 0, chInfo.subChannelCount - 1 do
				local ch = moho.layer:Channel(i, subID, moho.document)
				self:clearKeys(moho, ch)
			end
		end
	end
end

function DS_initialize:goThrough(moho, layer, nr)
	--
	
	moho:SetSelLayer(layer)
	if ((layer:LayerType() == MOHO.LT_GROUP) or (layer:LayerType() == MOHO.LT_SWITCH) or (layer:LayerType() == MOHO.LT_BONE)) then		
		--print("Group "..nr .." - "..layer:Name())
		self:getChannel(moho, layer)
		local layer = moho:LayerAsGroup(layer)
		for i= 0, layer:CountLayers()-1 do
		self:goThrough(moho, layer:Layer(i), i)
		end
	else
		self:getChannel(moho, layer)
		--print("      "..nr .." - "..layer:Name())
	end
	
end

function DS_initialize:Run(moho)    
	local numlayers = moho.document:CountLayers() --Do top layers
		for i = 0, numlayers - 1 do
			moho:SetSelLayer(moho.document:Layer(i))
			local layer = moho.document:Layer(i)
			self:goThrough(moho, layer, i)
		end
end
