-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_trackpoints"

-- **************************************************
-- General information about this script
-- **************************************************

DS_trackpoints = {}
function DS_trackpoints:Name()
	return "DS Track Points"
end

function DS_trackpoints:Version()
	return "1.0"
end

function DS_trackpoints:Description()
	return "Track Points"
end

function DS_trackpoints:Creator()
	return "dauid.com"
end

function DS_trackpoints:UILabel()
	return("DS Track Points")
end
-- **************************************************
-- Recurring values
-- **************************************************


-- **************************************************
-- The guts of this script
-- **************************************************


function DS_trackpoints:Run(moho)

local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end
	local Interpolation = 0
	local val1 = 0
	local val2 = 0
	local xTable={}
	local yTable={}
	local pv=LM.Vector2:new_local()
	local lv=LM.Vector3:new_local()
	local startFrame = moho.document:StartFrame()
	local endFrame = moho.document:EndFrame()
	local thePoint = nil
	
	for i = 0, mesh:CountPoints() - 1 do --Get the point we're looking for
			local pt = mesh:Point(i)
			if (pt.fSelected) then
			thePoint=mesh:Point(i)
				break
			end
	end
	
	if (thePoint == nil) then
	LM.GUI.Alert(LM.GUI.ALERT_INFO, "No point selected.", nil, nil, "OK", nil, nil)
	return
	end
	
	local theGroupLayer = (moho:CreateNewLayer(MOHO.LT_GROUP)) -- The group layer that contains everything
	theGroupLayer:SetName("Tracked motion")
	
	local ch = thePoint.fAnimPos
		for frame = 0, ch:Duration() do
			if (ch:HasKey(frame)) then
				if (ch.GetKeyInterpMode ~= nil) then
				Interpolation, val1, val2 = ch:GetKeyInterp(frame, Interpolation,val1, val2);
				end
				lv=theGroupLayer.fTranslation:GetValue(frame)
				pv = thePoint.fAnimPos:GetValue(frame)
				lv.x = pv.x
				lv.y = pv.y
				theGroupLayer.fTranslation:SetValue(frame, lv)
				theGroupLayer.fTranslation:SetKeyInterp(frame, Interpolation, val1, val2)
			end
		end
	

end